#include "CensorIO.h"
#include <Windows.h>

CensorIO::CensorIO() : hCom() {
}

CensorIO::~CensorIO() {
}

bool CensorIO::open() {
	// VA|[gI[v
	hCom = CreateFileA( "COM3", GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0 );
	if ( hCom == INVALID_HANDLE_VALUE ) {
		hCom = 0;
		return false;
	}
	DCB dcb;
	GetCommState( hCom, &dcb );
	dcb.BaudRate = 9600;
	dcb.fBinary = 1;
	dcb.fDtrControl = DTR_CONTROL_ENABLE;
	dcb.ByteSize = 8;
	SetCommState( hCom, &dcb );

	return true;
}

void CensorIO::close() {
	if ( hCom != 0 )
		CloseHandle( hCom );
}

unsigned int CensorIO::getValue() {

	if ( hCom == 0 )
		return -1;

	// VA|[gɑ΂ăf[^o͗v
	DWORD wroteBytes = 0;
	WriteFile( hCom, "1", 1, &wroteBytes, 0 );

	Sleep(10);

	// obt@݂̑`FbN
	// ݉\`FbN
	DWORD err = 0;
	COMSTAT state;
	ClearCommError( hCom, &err, &state );
	if ( state.cbInQue == 0 )
		return -1;

	// VA|[gǂݍݗv
	char str[65] = {};
	char s = 0;
	for ( int i = 0; i < 64; i++ ) {
		ReadFile( hCom, &s, 1, &wroteBytes, 0 );
		if ( wroteBytes == 0 ) {
			i--;
			continue;
		}

		if ( s == ',' )
			break;

		str[i] = s;
	}

	return atoi( str );
}
